Quassel IRC - Bug #1227

Switching channels on OSX, Macbook retina, Quassel 0.9 takes > 7 seconds
05/23/2013 09:41 PM - miohtama

Status: Resolved Start date: 05/23/2013
Priority: Normal Due date:

Assignee: % Done: 100%
Category: Quassel Client Estimated time: 0.00 hour

Target version:

Version: 0.9-pre 0S: Any

Description
The following scenario

- Core upgraded to 0.9

- Client upgraded to 0.9

- OSX Mountain Lion

- Having channel and private message buffers from freenode.net network

- When starting the client

- when choosing any buffer for the first time

- There is unresponsiveness of 5-10 seconds before channel is opened, the application goes to unresponsiveness mode
Below is the stacktrace from the slowdown grabbed from Xcode Instruments.

Note: There is noticeable backlog of events, but the issue did not appear on 0.8 and it also happens for buffers having only recent
history (< 3 days, only couple of messages)

{{f

Running Time  Self Symbol Name

7411.0ms 99.9% 0.0 Main Thread 0x83519

7411.0ms 99.9% 0.0 start

7411.0ms 99.9% 0.0 main

7411.0ms 99.9% 0.0 QCoreApplication::exec()

7411.0ms 99.9% 0.0 QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)
7411.0ms 99.9% 0.0 QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)

7411.0ms 99.9% 0.0 QEventDispatcherMac::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
7411.0ms 99.9% 0.0 -[NSApplication run]

7401.0ms 99.8% 0.0 -[QNSApplication sendEvent:]

7401.0ms 99.8% 0.0 -[INSApplication sendEvent:]

7401.0ms 99.8% 0.0 -[QCocoaWindow sendEvent:]

7401.0ms 99.8% 0.0 -[NSWindow sendEvent:]

7399.0ms 99.8% 0.0 gt_mac_handleMouseEvent(NSEvent*, QEvent::Type, Qt::MouseButton, QWidget*, bool)
7399.0ms 99.8% 0.0 QApplicationPrivate::sendMouseEvent(QWidget*, QMouseEvent*, QWidget*, QWidget*,
QWidget**, QPointer<QWidget>&, bool)

7399.0ms 99.8% 0.0 QCoreApplication::notifylnternal(QObject*, QEvent*)

7399.0ms 99.8% 0.0 QApplication::notify(QObject*, QEvent*)

7399.0ms 99.8% 0.0 QApplicationPrivate::notify_helper(QObject*, QEvent*)

7399.0ms 99.8% 0.0 QCoreApplicationPrivate::sendThroughObjectEventFilters(QObject*, QEvent*)
7399.0ms 99.8% 0.0 QAbstractScrollAreaFilter::eventFilter(QObject*, QEvent*)

7399.0ms 99.8% 0.0 QTreeView::viewportEvent(QEvent*)

7399.0ms 99.8% 0.0 QAbstractltemView::viewportEvent(QEvent*)

7399.0ms 99.8% 0.0 QAbstractScrollArea::viewportEvent(QEvent*)

7399.0ms 99.8% 0.0 QFrame::event(QEvent*)

7399.0ms 99.8% 0.0 QWidget::event(QEvent*)

7399.0ms 99.8% 0.0 QAbstractltemView::mousePressEvent(QMouseEvent*)

7399.0ms 99.8% 0.0 QltemSelectionModel::setCurrentindex(QModellndex const&,

QFlags<QltemSelectionModel::SelectionFlag>)
7399.0ms 99.8% 0.0 QltemSelectionModel::currentChanged(QModellndex const&, QModellndex const&)

7399.0ms 99.8% 0.0 QMetaObiject::activate(QObject*, QMetaObject const*, int, void**)

7399.0ms 99.8% 0.0 SelectionModelSynchronizer::syncedCurrentChanged(QModellndex const&,
QModellndex const&)

7399.0ms 99.8% 0.0 QltemSelectionModel::setCurrentindex(QModellndex const&,
QFlags<QltemSelectionModel::SelectionFlag>)

7399.0ms 99.8% 0.0 QltemSelectionModel::currentChanged(QModelindex const&, QModellndex const&)
7399.0ms 99.8% 0.0 QMetaObject::activate(QObject*, QMetaObject const*, int, void**)
7399.0ms 99.8% 0.0 BufferWidget::currentChanged(QModellndex const&, QModellndex const&)
7399.0ms 99.8% 0.0 AbstractBufferContainer::currentChanged(QModellndex const&, QModellndex
const&)

7399.0ms 99.8% 0.0 AbstractBufferContainer::setCurrentBuffer(Bufferld)

7399.0ms 99.8% 0.0 BufferWidget::createChatView(Bufferld)

7399.0ms 99.8% 0.0 ChatView::ChatView(Bufferld, QWidget*)

7399.0ms 99.8% 0.0 ChatView::init(MessageFilter*)

7399.0ms 99.8% 0.0 ChatScene::ChatScene(QAbstractltemModel*, QString const&, double,
ChatView®)

7398.0ms 99.7% 0.0 QSortFilterProxyModel::rowCount(QModellndex const&) const
7398.0ms 99.7% 0.0 QSortFilterProxyModelPrivate::create_mapping(QModellndex const&) const
7398.0ms 99.7% 2.0 MessageFilter::filterAcceptsRow(int, QModellndex const&) const
7319.0ms 98.7% 4.0 IgnoreListManager::_match(QString const&, QString const&, Message:: Type,
QString const&, QString const&)

3170.0ms 42.7% 1.0 QRegExp::exactMatch(QString const&) const

3159.0ms 42.6% 1.0 prepareEngine_helper(QRegExpPrivate*)

531.0ms 7.1% 0.0 QRegExp::~QRegExp()

352.0ms 4.7% 0.0 QRegExp::setCaseSensitivity(Qt::CaseSensitivity)

89.0ms 1.2% 0.0 IgnoreListManager::scopeMatch(QString const&, QString const&) const
7.0ms 0.0% 1.0 QRegExpMatchState::prepareForMatch(QRegExpEngine*)

1.0ms 0.0% 0.0 QRegExp::QRegExp(QString const&, Qt::CaseSensitivity,
QRegExp::PatternSyntax)

1.0ms 0.0% 1.0 QRegExp::~QRegExp()

1.0ms 0.0% 1.0 QString::operator=(QString const&)

1.0ms 0.0% 1.0 QRegExpMatchState::match(QChar const*, int, int, bool, bool, int)

1.0ms 0.0% 1.0 QList<QString>::~QList()

1.0ms 0.0% 1.0 QString::fromAscii_helper(char const*, int)

1.0ms 0.0% 0.0 free

40.0ms 0.5% 1.0 MessageModel::data(QModellndex const&, int) const

21.0ms 0.2% 2.0 clear(QVariant::Private*)

8.0ms 0.1% 1.0 BufferInfo::bufferName() const

2.0ms 0.0% 2.0 Message::~Message()

2.0ms 0.0% 2.0 NetworkModel::networkld(Bufferld) const

2.0ms 0.0% 2.0 QVariant::constData() const

1.0ms 0.0% 1.0 QMetaType::destroy(int, void*)

1.0ms 0.0% 1.0 Message gvariant_cast<Message>(QVariant const&)
Associated revisions

Revision 8677a82a - 03/20/2014 09:58 PM - Bombe

Only create the regular expression for content/sender matches once.

Fixes #1227.

Revision 17fe4859 - 03/20/2014 10:46 PM - Bombe

Only create the regular expression for content/sender matches once.

Fixes #1227.

History

#1 - 05/23/2013 09:43 PM - miohtama

Also if it was unclear this happens only for my freenode.net buffers, not for other networks (ircnet, quakenet, irc.mozilla.org)

#2 - 05/23/2013 09:44 PM - miohtama

Looks like clearing the ignore list resolved the issue.
#3 - 05/28/2013 02:09 PM - sandsmark

| suspect that it is partly because the QRegExp is recreated for every line.

#4 - 06/19/2013 01:25 PM - jeroendeneef

| also have the issue on Windows 7.
However, my ignore list is empty.

#5 - 02/02/2014 12:51 PM - Bombe

I have moved the regex creation into the IgnoreListltem and that seems to have sped up the process of initally filling new buffers. However, there is
still a noticable delay.

https://github.com/Bombe/quassel/tree/issue-1227

#6 - 03/20/2014 10:44 PM - Bombe
- Status changed from New to Resolved

- % Done changed from 0 to 100

Applied in changeset quassellcommit:8677a82a6664da67c67610d0b438ee17904b12fb.
